package testkinect;

public class H_FaceTracKLib {
	/*
	// Face Tracking Error Codes
	#define FT_FACILITY                             0xFAC   // FT facility error code               // Face Tracking facility error code
	#define FT_ERROR_INVALID_MODELS                 MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 1)    // Returned when the face tracking models loaded by the tracking engine have incorrect format
	#define FT_ERROR_INVALID_INPUT_IMAGE            MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 2)    // Returned when passed input image is invalid
	#define FT_ERROR_FACE_DETECTOR_FAILED           MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 3)    // Returned when face tracking fails due to face detection errors
	#define FT_ERROR_AAM_FAILED                     MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 4)    // Returned when face tracking fails due to errors in tracking individual face parts
	#define FT_ERROR_NN_FAILED                      MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 5)    // Returned when face tracking fails due to inability of the Neural Network to find nose, mouth corners and eyes
	#define FT_ERROR_UNINITIALIZED                  MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 6)    // Returned when uninitialized face tracker is used
	#define FT_ERROR_INVALID_MODEL_PATH             MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 7)    // Returned when a file path to the face model files is invalid or when the model files could not be located
	#define FT_ERROR_EVAL_FAILED                    MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 8)    // Returned when face tracking worked but later evaluation found that the quality of the results was poor
	#define FT_ERROR_INVALID_CAMERA_CONFIG          MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 9)    // Returned when the passed camera configuration is invalid
	#define FT_ERROR_INVALID_3DHINT                 MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 10)   // Returned when the passed 3D hint vectors contain invalid values (for example out of range)
	#define FT_ERROR_HEAD_SEARCH_FAILED             MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 11)   // Returned when the system cannot find the head area in the passed data based on passed 3D hint vectors or region of interest rectangle
	#define FT_ERROR_USER_LOST                      MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 12)   // Returned when the user ID of the subject being tracked is switched or lost so we should call StartTracking on next call for tracking face
	#define FT_ERROR_KINECT_DLL_FAILED              MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 13)   // Returned when Kinect DLL failed to load
	#define FT_ERROR_KINECT_NOT_CONNECTED           MAKE_HRESULT(SEVERITY_ERROR, FT_FACILITY, 14)   // Returned when Kinect sensor was not detected in the system 
	 */
	static final int FT_ERROR_FACE_DETECTOR_FAILED = 0x8FAC0003;
	
	/*
	typedef enum _FTIMAGEFORMAT
	{
	    FTIMAGEFORMAT_INVALID = 0,          // Invalid format
	    FTIMAGEFORMAT_UINT8_GR8,            // Grayscale image where each pixel is 1 byte (or 8 bits). 
	    FTIMAGEFORMAT_UINT8_R8G8B8,         // RGB image (same as ARGB but without an alpha channel).
	    FTIMAGEFORMAT_UINT8_X8R8G8B8,       // Same as ARGB (the alpha channel byte is present but not used). 
	    FTIMAGEFORMAT_UINT8_A8R8G8B8,       // ARGB format (the first byte is the alpha transparency channel; remaining bytes are 8-bit red, green, and blue channels). 
	    FTIMAGEFORMAT_UINT8_B8G8R8X8,       // Same as BGRA (the alpha channel byte is present but not used). 
	    FTIMAGEFORMAT_UINT8_B8G8R8A8,       // BGRA format (the last byte is the alpha transparency channel; remaining bytes are 8-bit red, green, and blue channels). 
	    FTIMAGEFORMAT_UINT16_D16,           // 16-bit per pixel depth data that represents the distance to a pixel in millimeters. 
	    FTIMAGEFORMAT_UINT16_D13P3          // 16-bit per pixel depth data that represents the distance to a pixel in millimeters. The last three bits represent the user ID (Kinect's depth data format).
	} FTIMAGEFORMAT;
	 */
	static final int
		FTIMAGEFORMAT_INVALID        = 0,
		FTIMAGEFORMAT_UINT8_GR8      = 1,
		FTIMAGEFORMAT_UINT8_R8G8B8   = 2,
		FTIMAGEFORMAT_UINT8_X8R8G8B8 = 3,
		FTIMAGEFORMAT_UINT8_A8R8G8B8 = 4,
		FTIMAGEFORMAT_UINT8_B8G8R8X8 = 5,
		FTIMAGEFORMAT_UINT8_B8G8R8A8 = 6,
		FTIMAGEFORMAT_UINT16_D16     = 7,
		FTIMAGEFORMAT_UINT16_D13P3   = 8;
}
