package testkinect;

public class H_NuiSkeleton {
	/*
	//  Number of NUI_SKELETON_DATA elements in NUI_SKELETON_FRAME
	#define NUI_SKELETON_COUNT 6
	 */
	static final int NUI_SKELETON_COUNT = 6;
	
	/*
	#define NUI_SKELETON_INVALID_TRACKING_ID 0
	 */
	static final int NUI_SKELETON_INVALID_TRACKING_ID = 0;
	
	/*
	typedef enum _NUI_SKELETON_POSITION_TRACKING_STATE
	{
	    NUI_SKELETON_POSITION_NOT_TRACKED = 0,
	    NUI_SKELETON_POSITION_INFERRED,
	    NUI_SKELETON_POSITION_TRACKED
	} NUI_SKELETON_POSITION_TRACKING_STATE;
	*/
	static final int
		NUI_SKELETON_POSITION_NOT_TRACKED = 0,
		NUI_SKELETON_POSITION_INFERRED    = 1,
		NUI_SKELETON_POSITION_TRACKED     = 2;
	
	/*
	typedef enum _NUI_SKELETON_TRACKING_STATE
	{
	    NUI_SKELETON_NOT_TRACKED = 0,
	    NUI_SKELETON_POSITION_ONLY,
	    NUI_SKELETON_TRACKED
	} NUI_SKELETON_TRACKING_STATE;
	 */
	static final int
		NUI_SKELETON_NOT_TRACKED   = 0,
		NUI_SKELETON_POSITION_ONLY = 1,
		NUI_SKELETON_TRACKED       = 2;
	
	/*
	typedef enum _NUI_SKELETON_POSITION_INDEX
	{
	    NUI_SKELETON_POSITION_HIP_CENTER = 0,
	    NUI_SKELETON_POSITION_SPINE,
	    NUI_SKELETON_POSITION_SHOULDER_CENTER,
	    NUI_SKELETON_POSITION_HEAD,
	    NUI_SKELETON_POSITION_SHOULDER_LEFT,
	    NUI_SKELETON_POSITION_ELBOW_LEFT,
	    NUI_SKELETON_POSITION_WRIST_LEFT,
	    NUI_SKELETON_POSITION_HAND_LEFT,
	    NUI_SKELETON_POSITION_SHOULDER_RIGHT,
	    NUI_SKELETON_POSITION_ELBOW_RIGHT,
	    NUI_SKELETON_POSITION_WRIST_RIGHT,
	    NUI_SKELETON_POSITION_HAND_RIGHT,
	    NUI_SKELETON_POSITION_HIP_LEFT,
	    NUI_SKELETON_POSITION_KNEE_LEFT,
	    NUI_SKELETON_POSITION_ANKLE_LEFT,
	    NUI_SKELETON_POSITION_FOOT_LEFT,
	    NUI_SKELETON_POSITION_HIP_RIGHT,
	    NUI_SKELETON_POSITION_KNEE_RIGHT,
	    NUI_SKELETON_POSITION_ANKLE_RIGHT,
	    NUI_SKELETON_POSITION_FOOT_RIGHT,
	    NUI_SKELETON_POSITION_COUNT
	} NUI_SKELETON_POSITION_INDEX;
	 */
	static final int
	    NUI_SKELETON_POSITION_HIP_CENTER      = 0,
	    NUI_SKELETON_POSITION_SPINE           = 1,
	    NUI_SKELETON_POSITION_SHOULDER_CENTER = 2,
	    NUI_SKELETON_POSITION_HEAD            = 3,
	    NUI_SKELETON_POSITION_SHOULDER_LEFT   = 4,
	    NUI_SKELETON_POSITION_ELBOW_LEFT      = 5,
	    NUI_SKELETON_POSITION_WRIST_LEFT      = 6,
	    NUI_SKELETON_POSITION_HAND_LEFT       = 7,
	    NUI_SKELETON_POSITION_SHOULDER_RIGHT  = 8,
	    NUI_SKELETON_POSITION_ELBOW_RIGHT     = 9,
	    NUI_SKELETON_POSITION_WRIST_RIGHT     = 10,
	    NUI_SKELETON_POSITION_HAND_RIGHT      = 11,
	    NUI_SKELETON_POSITION_HIP_LEFT        = 12,
	    NUI_SKELETON_POSITION_KNEE_LEFT       = 13,
	    NUI_SKELETON_POSITION_ANKLE_LEFT      = 14,
	    NUI_SKELETON_POSITION_FOOT_LEFT       = 15,
	    NUI_SKELETON_POSITION_HIP_RIGHT       = 16,
	    NUI_SKELETON_POSITION_KNEE_RIGHT      = 17,
	    NUI_SKELETON_POSITION_ANKLE_RIGHT     = 18,
	    NUI_SKELETON_POSITION_FOOT_RIGHT      = 19,
	    NUI_SKELETON_POSITION_COUNT           = 20;
	
	/*
	#define FLT_EPSILON     1.192092896e-07F        // smallest such that 1.0+FLT_EPSILON != 1.0
	 */
	static final float FLT_EPSILON = 1.192092896e-07F;
	
	/*
	// Assuming a pixel resolution of 320x240
	// x_pixelcoord = (x_meters) * NUI_CAMERA_SKELETON_TO_DEPTH_IMAGE_MULTIPLIER_320x240 / z_meters + 160;
	// y_pixelcoord = (y_meters) * NUI_CAMERA_SKELETON_TO_DEPTH_IMAGE_MULTIPLIER_320x240 / z_meters + 120;
	#define NUI_CAMERA_SKELETON_TO_DEPTH_IMAGE_MULTIPLIER_320x240 (NUI_CAMERA_DEPTH_NOMINAL_FOCAL_LENGTH_IN_PIXELS)
	 */
	static final float NUI_CAMERA_SKELETON_TO_DEPTH_IMAGE_MULTIPLIER_320x240 
			= H_NuiImageCamera.NUI_CAMERA_DEPTH_NOMINAL_FOCAL_LENGTH_IN_PIXELS;
	
}
