package testkinect;

import utildll.*;

/*
struct FT_SENSOR_DATA
{
    IFTImage* pVideoFrame;  // a pointer to a video frame. Must be synchronized with the depth frame passed in the same structure.
    IFTImage* pDepthFrame;  // a pointer to a depth frame. Must be synchronized with the video frame passed in the same structure.
    FLOAT     ZoomFactor;   // camerafs zoom factor for the video frame (value 1.0f means - no zoom is used)
    POINT     ViewOffset;   // the left, top coordinates of the video frame view area read from the camerafs native frame (which may have a higher resolution than what is returned to a PC). 
};
 */
public class Struct_FT_SENSOR_DATA {
	long pVideoFrame; // IFTImage*
	long pDepthFrame; // IFTImage*
	float ZoomFactor;
	@_Fixed Struct_POINT ViewOffset;
	
	Struct_FT_SENSOR_DATA(long pVideoFrame, long pDepthFrame, float ZoomFactor, Struct_POINT ViewOffset) {
		this.pVideoFrame = pVideoFrame;
		this.pDepthFrame = pDepthFrame;
		this.ZoomFactor = ZoomFactor;
		this.ViewOffset = ViewOffset;
	}
}
