package testkinect;

import utildll.*;
/*
typedef struct _IID
{
    unsigned long x;
    unsigned short s1;
    unsigned short s2;
    unsigned char  c[8];
} IID;
 */
public class Struct_IID {
	int x;
	short s1;
	short s2;
	@_Fixed byte[] c = new byte[8];
	
	public Struct_IID(int x, int s1, int s2, int c0, int c1, int c2,
			int c3, int c4, int c5, int c6, int c7){
		this.x = x; this.s1 = (short)s1; this.s2 = (short)s2;
		this.c[0] = (byte)c0; this.c[1] = (byte)c1; this.c[2] = (byte)c2;
		this.c[3] = (byte)c3; this.c[4] = (byte)c4; this.c[5] = (byte)c5;
		this.c[6] = (byte)c6; this.c[7] = (byte)c7; 
	}
	public Struct_IID(){
		this(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0); 
	}
	public Struct_IID(String str){
		this(
			(int)Long.parseLong(str.substring( 0,  8), 16),
			Integer.parseInt(str.substring( 9, 13), 16),
			Integer.parseInt(str.substring(14, 18), 16),
			Integer.parseInt(str.substring(19, 21), 16),
			Integer.parseInt(str.substring(21, 23), 16),
			Integer.parseInt(str.substring(24, 26), 16),
			Integer.parseInt(str.substring(26, 28), 16),
			Integer.parseInt(str.substring(28, 30), 16),
			Integer.parseInt(str.substring(30, 32), 16),
			Integer.parseInt(str.substring(32, 34), 16),
			Integer.parseInt(str.substring(34, 36), 16));
	}
	public String toString_IID(){
		return String.format("%1$08x-%2$04x-%3$04x-%4$02x%5$02x-%6$02x%7$02x%8$02x%9$02x%10$02x%11$02x",
				this.x, this.s1, this.s2, this.c[0], this.c[1], this.c[2],
				this.c[3], this.c[4], this.c[5], this.c[6], this.c[7]);
	}
	public boolean isEqualIID(Struct_IID id){
		return this.x == id.x && this.s1 == id.s1 && this.s2 == id.s2
		&& this.c[0] == id.c[0] && this.c[1] == id.c[1] && this.c[2] == id.c[2] 
		&& this.c[3] == id.c[3] && this.c[4] == id.c[4] && this.c[5] == id.c[5] 
		&& this.c[6] == id.c[6] && this.c[7] == id.c[7];
	}
}
