package testkinect;

import utildll.*;

class Wrp_INuiFrameTexture {
	static final int CHARSET = Arg.UNICODE;
	long rameTexture = 0;
	static final int 
		IDX_LockRect = 5,
		IDX_UnlockRect = 7;
	
	Wrp_INuiFrameTexture(long rameTexture) {
		this.rameTexture = rameTexture;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}
	
	/*
	HRESULT LockRect(
	         UINT Level,
	         NUI_LOCKED_RECT *pLockedRect,
	         RECT *pRect,
	         DWORD Flags
	)
	 */
	class Arg_LockRect extends Arg_property {
		private int Level;
		private Struct_NUI_LOCKED_RECT pLockedRect;
		private Struct_RECT pRect;
		private int Flags;

		Arg_LockRect(int Level, Struct_NUI_LOCKED_RECT pLockedRect,	Struct_RECT pRect, int Flags) {
			this.Level = Level;
			this.pLockedRect = pLockedRect;
			this.pRect = pRect;
			this.Flags = Flags;
		}
	}

	int LockRect(int Level, Struct_NUI_LOCKED_RECT pLockedRect,	Struct_RECT pRect, int Flags)
			throws Exception_KINECT {
		Arg_LockRect alr = new Arg_LockRect(Level, pLockedRect, pRect, Flags);

		int intRtn = JInvoker.callIntMethod(rameTexture, IDX_LockRect, alr);
		
		System.out.println("LockRect rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(alr.getLastError()));
		
		if (alr.getLastError() < 0) throw new Exception_KINECT("LockRect");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("LockRect");

		return intRtn;
	}

	/*
	HRESULT UnlockRect(
	         UINT Level
	)
	 */
	class Arg_UnlockRect extends Arg_property {
		private int Level;

		Arg_UnlockRect(int Level) {
			this.Level = Level;
		}
	}

	int UnlockRect(int Level) throws Exception_KINECT {
		Arg_UnlockRect aur = new Arg_UnlockRect(Level);

		int intRtn = JInvoker.callIntMethod(rameTexture, IDX_UnlockRect, aur);
		
		System.out.println("UnlockRect rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(aur.getLastError()));
		
		if (aur.getLastError() < 0) throw new Exception_KINECT("UnlockRect");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("UnlockRect");

		return intRtn;
	}

}
