package testkinect;

import utildll.*;

public class Wrp_INuiFusionColorMesh {
	static final int CHARSET = Arg.UNICODE;
	long fusionColorMesh = 0;
	static final int 
		IDX_Release = 2,
		IDX_VertexCount = 3,
		IDX_GetVertices = 4,
		IDX_TriangleVertexIndexCount = 7,
		IDX_GetTriangleIndices = 8,
		IDX_ColorCount = 9,
		IDX_GetColors = 10;
		
	Wrp_INuiFusionColorMesh(long fusionColorMesh) {
		this.fusionColorMesh = fusionColorMesh;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(fusionColorMesh, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	UINT VertexCount()
	 */
	class Arg_VertexCount extends Arg_property {
	}
	
	int VertexCount() throws Exception_KINECT {
		Arg_VertexCount avc = new Arg_VertexCount();

		int intRtn = JInvoker.callIntMethod(fusionColorMesh, IDX_VertexCount, avc);
		
		System.out.println("VertexCount rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(avc.getLastError()));
		
		if (avc.getLastError() < 0) throw new Exception_KINECT("VertexCount");

		return intRtn;
	}
	
	/*
	HRESULT GetVertices(
	         const Vector3 **pVertices
	)
	 */
	class Arg_GetVertices extends Arg_property {
		private long[] pVertices; // const Vector3 **
		
		Arg_GetVertices(long[] pVertices) {
			this.pVertices = pVertices;
		}
	}
	
	int GetVertices(long[] pVertices) throws Exception_KINECT {
		Arg_GetVertices agv = new Arg_GetVertices(pVertices);

		int intRtn = JInvoker.callIntMethod(fusionColorMesh, IDX_GetVertices, agv);
		
		System.out.println("GetVertices rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(agv.getLastError()));
		
		if (agv.getLastError() < 0) throw new Exception_KINECT("GetVertices");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetVertices");

		return intRtn;
	}
	
	/*
	UINT TriangleVertexIndexCount()
	 */
	class Arg_TriangleVertexIndexCount extends Arg_property {
	}
	
	int TriangleVertexIndexCount() throws Exception_KINECT {
		Arg_TriangleVertexIndexCount atvic = new Arg_TriangleVertexIndexCount();

		int intRtn = JInvoker.callIntMethod(fusionColorMesh, IDX_TriangleVertexIndexCount, atvic);
		
		System.out.println("TriangleVertexIndexCount rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(atvic.getLastError()));
		
		if (atvic.getLastError() < 0) throw new Exception_KINECT("TriangleVertexIndexCount");

		return intRtn;
	}
	
	/*
	HRESULT GetTriangleIndices(
	         const int **pTriangleVertexIndices
	)
	 */
	class Arg_GetTriangleIndices extends Arg_property {
		private long[] pTriangleVertexIndices; // const int **
		
		Arg_GetTriangleIndices(long[] pTriangleVertexIndices) {
			this.pTriangleVertexIndices = pTriangleVertexIndices;
		}
	}
	
	int GetTriangleIndices(long[] pTriangleVertexIndices) throws Exception_KINECT {
		Arg_GetTriangleIndices agti = new Arg_GetTriangleIndices(pTriangleVertexIndices);

		int intRtn = JInvoker.callIntMethod(fusionColorMesh, IDX_GetTriangleIndices, agti);
		
		System.out.println("GetTriangleIndices rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(agti.getLastError()));
		
		if (agti.getLastError() < 0) throw new Exception_KINECT("GetTriangleIndices");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetTriangleIndices");

		return intRtn;
	}
	
	/*
	UINT ColorCount()
	 */
	class Arg_ColorCount extends Arg_property {
	}
	
	int ColorCount() throws Exception_KINECT {
		Arg_ColorCount acc = new Arg_ColorCount();

		int intRtn = JInvoker.callIntMethod(fusionColorMesh, IDX_ColorCount, acc);
		
		System.out.println("ColorCount rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(acc.getLastError()));
		
		if (acc.getLastError() < 0) throw new Exception_KINECT("ColorCount");

		return intRtn;
	}
	
	/*
	HRESULT GetColors(
	         const int **pColors
	)
	 */
	class Arg_GetColors extends Arg_property {
		private long[] pColors; // const int **
		
		Arg_GetColors(long[] pColors) {
			this.pColors = pColors;
		}
	}
	
	int GetColors(long[] pColors) throws Exception_KINECT {
		Arg_GetColors agc = new Arg_GetColors(pColors);

		int intRtn = JInvoker.callIntMethod(fusionColorMesh, IDX_GetColors, agc);
		
		System.out.println("GetColors rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(agc.getLastError()));
		
		if (agc.getLastError() < 0) throw new Exception_KINECT("GetColors");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetColors");

		return intRtn;
	}
	
}
