package testkinect;

import utildll.*;

public class Wrp_INuiFusionColorReconstruction {
	static final int CHARSET = Arg.UNICODE;
	long fusionColorReconst = 0;
	static final int 
		IDX_Release = 2,
		IDX_ResetReconstruction = 3,
		IDX_GetCurrentWorldToCameraTransform = 5,
		IDX_ProcessFrame = 8,
		IDX_CalculatePointCloud = 9,
		IDX_CalculateMesh = 10,
		IDX_DepthToDepthFloatFrame = 13,
		IDX_SmoothDepthFloatFrame = 14;
	Wrp_INuiFusionColorReconstruction(long fusionColorReconst) {
		this.fusionColorReconst = fusionColorReconst;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(fusionColorReconst, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT ResetReconstruction(
	         const Matrix4 *pInitialWorldToCameraTransform,
	         const Matrix4 *pWorldToVolumeTransform
	)
	 */
	class Arg_ResetReconstruction extends Arg_property {
		private @_Const Struct_Matrix4 pInitialWorldToCameraTransform;
		private @_Const Struct_Matrix4 pWorldToVolumeTransform;

		Arg_ResetReconstruction(Struct_Matrix4 pInitialWorldToCameraTransform,
				Struct_Matrix4 pWorldToVolumeTransform) {
			this.pInitialWorldToCameraTransform = pInitialWorldToCameraTransform;
			this.pWorldToVolumeTransform = pWorldToVolumeTransform;
		}
	}

	int ResetReconstruction(Struct_Matrix4 pInitialWorldToCameraTransform,
			Struct_Matrix4 pWorldToVolumeTransform) throws Exception_KINECT {
		Arg_ResetReconstruction arr = new Arg_ResetReconstruction(pInitialWorldToCameraTransform,
				pWorldToVolumeTransform);

		int intRtn = JInvoker.callIntMethod(fusionColorReconst, IDX_ResetReconstruction, arr);
		
		System.out.println("ResetReconstruction rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arr.getLastError()));
		
		if (arr.getLastError() < 0) throw new Exception_KINECT("ResetReconstruction");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ResetReconstruction");

		return intRtn;
	}

	/*
	HRESULT GetCurrentWorldToCameraTransform(
	         Matrix4 *pWorldToCameraTransform
	)
	 */
	class Arg_GetCurrentWorldToCameraTransform extends Arg_property {
		private Struct_Matrix4 pWorldToCameraTransform;

		Arg_GetCurrentWorldToCameraTransform(Struct_Matrix4 pWorldToCameraTransform) {
			this.pWorldToCameraTransform = pWorldToCameraTransform;
		}
	}

	int GetCurrentWorldToCameraTransform(Struct_Matrix4 pWorldToCameraTransform) throws Exception_KINECT {
		Arg_GetCurrentWorldToCameraTransform agcwtct = new Arg_GetCurrentWorldToCameraTransform(
				pWorldToCameraTransform);

		int intRtn = JInvoker.callIntMethod(fusionColorReconst, IDX_GetCurrentWorldToCameraTransform, agcwtct);
		
		System.out.println("GetCurrentWorldToCameraTransform rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(agcwtct.getLastError()));
		
		if (agcwtct.getLastError() < 0) throw new Exception_KINECT("GetCurrentWorldToCameraTransform");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetCurrentWorldToCameraTransform");

		return intRtn;
	}

	/*
	HRESULT ProcessFrame(
	         const NUI_FUSION_IMAGE_FRAME *pDepthFloatFrame,
	         const NUI_FUSION_IMAGE_FRAME *pColorFrame,
	         USHORT maxAlignIterationCount,
	         USHORT maxIntegrationWeight,
	         FLOAT maxColorIntegrationAngle,
	         const Matrix4 *pWorldToCameraTransform
	)
	 */
	class Arg_ProcessFrame extends Arg_property {
		private long pDepthFloatFrame; // const NUI_FUSION_IMAGE_FRAME *
		private long pColorFrame; // const NUI_FUSION_IMAGE_FRAME *
		private short maxAlignIterationCount;
		private short maxIntegrationWeight;
		private float maxColorIntegrationAngle;
		private @_Const Struct_Matrix4 pWorldToCameraTransform;

		Arg_ProcessFrame(long pDepthFloatFrame, long pColorFrame, short maxAlignIterationCount,
				short maxIntegrationWeight, float maxColorIntegrationAngle,
				Struct_Matrix4 pWorldToCameraTransform) {
			this.pDepthFloatFrame = pDepthFloatFrame;
			this.pColorFrame = pColorFrame;
			this.maxAlignIterationCount = maxAlignIterationCount;
			this.maxIntegrationWeight = maxIntegrationWeight;
			this.maxColorIntegrationAngle = maxColorIntegrationAngle;
			this.pWorldToCameraTransform = pWorldToCameraTransform;
		}
	}

	int ProcessFrame(long pDepthFloatFrame, long pColorFrame, short maxAlignIterationCount,
			short maxIntegrationWeight, float maxColorIntegrationAngle,
			Struct_Matrix4 pWorldToCameraTransform) throws Exception_KINECT {
		Arg_ProcessFrame apf = new Arg_ProcessFrame(pDepthFloatFrame, pColorFrame, 
				maxAlignIterationCount, maxIntegrationWeight,
				maxColorIntegrationAngle, pWorldToCameraTransform);

		int intRtn = JInvoker.callIntMethod(fusionColorReconst, IDX_ProcessFrame, apf);
		
		System.out.println("ProcessFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(apf.getLastError()));
		
		if (apf.getLastError() < 0) throw new Exception_KINECT("ProcessFrame");
		if (H_WinError.FAILED(intRtn))
			if (intRtn != H_NuiKinectFusionApi.E_NUI_FUSION_TRACKING_ERROR)
				throw new Exception_KINECT("ProcessFrame");

		return intRtn;
	}
	
	/*
	HRESULT CalculatePointCloud(
	         const NUI_FUSION_IMAGE_FRAME *pPointCloudFrame,
	         const NUI_FUSION_IMAGE_FRAME *pColorFrame,
	         const Matrix4 *pWorldToCameraTransform
	)
	 */
	class Arg_CalculatePointCloud extends Arg_property {
		private long pPointCloudFrame; // const NUI_FUSION_IMAGE_FRAME *
		private long pColorFrame; // const NUI_FUSION_IMAGE_FRAME *
		private @_Const Struct_Matrix4 pWorldToCameraTransform;

		Arg_CalculatePointCloud(long pPointCloudFrame, long pColorFrame,
				Struct_Matrix4 pWorldToCameraTransform) {
			this.pPointCloudFrame = pPointCloudFrame;
			this.pColorFrame = pColorFrame;
			this.pWorldToCameraTransform = pWorldToCameraTransform;
		}
	}

	int CalculatePointCloud(long pPointCloudFrame, long pColorFrame, 
			Struct_Matrix4 pWorldToCameraTransform) throws Exception_KINECT {
		Arg_CalculatePointCloud acpc = new Arg_CalculatePointCloud(pPointCloudFrame,
				pColorFrame, pWorldToCameraTransform);

		int intRtn = JInvoker.callIntMethod(fusionColorReconst, IDX_CalculatePointCloud, acpc);
		
		System.out.println("CalculatePointCloud rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(acpc.getLastError()));
		
		if (acpc.getLastError() < 0) throw new Exception_KINECT("CalculatePointCloud");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CalculatePointCloud");

		return intRtn;
	}
			
	/*
	HRESULT CalculateMesh(
	         UINT voxelStep,
	         INuiFusionColorMesh **ppMesh
	)
	 */
	class Arg_CalculateMesh extends Arg_property {
		private int voxelStep;
		private long[] ppMesh; // INuiFusionColorMesh **

		Arg_CalculateMesh(int voxelStep, long[] ppMesh) {
			this.voxelStep = voxelStep;
			this.ppMesh = ppMesh;
		}
	}

	int CalculateMesh(int voxelStep, long[] ppMesh) throws Exception_KINECT {
		Arg_CalculateMesh acm = new Arg_CalculateMesh(voxelStep, ppMesh);

		int intRtn = JInvoker.callIntMethod(fusionColorReconst, IDX_CalculateMesh, acm);
		
		System.out.println("CalculateMesh rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(acm.getLastError()));
		
		if (acm.getLastError() < 0) throw new Exception_KINECT("CalculateMesh");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CalculateMesh");

		return intRtn;
	}
	
	/*
	HRESULT DepthToDepthFloatFrame(
	         const NUI_DEPTH_IMAGE_PIXEL *pDepthImageData,
	         UINT countDepthImageDataBytes,
	         const NUI_FUSION_IMAGE_FRAME *pDepthFloatFrame,
	         FLOAT minDepthClip,
	         FLOAT maxDepthClip,
	         BOOL mirrorDepth
	)
	 */
	class Arg_DepthToDepthFloatFrame extends Arg_property {
		private long pDepthImageData; // const NUI_DEPTH_IMAGE_PIXEL *
		private int countDepthImageDataBytes;
		private long pDepthFloatFrame; // const NUI_FUSION_IMAGE_FRAME *
		private float minDepthClip;
		private float maxDepthClip;
		private boolean mirrorDepth;

		Arg_DepthToDepthFloatFrame(long pDepthImageData, int countDepthImageDataBytes,
				long pDepthFloatFrame, float minDepthClip, float maxDepthClip, boolean mirrorDepth) {
			this.pDepthImageData = pDepthImageData;
			this.countDepthImageDataBytes = countDepthImageDataBytes;
			this.pDepthFloatFrame = pDepthFloatFrame;
			this.minDepthClip = minDepthClip;
			this.maxDepthClip = maxDepthClip;
			this.mirrorDepth = mirrorDepth;
		}
	}
	
	int DepthToDepthFloatFrame(long pDepthImageData, int countDepthImageDataBytes,
			long pDepthFloatFrame, float minDepthClip, float maxDepthClip,
			boolean mirrorDepth) throws Exception_KINECT {
		Arg_DepthToDepthFloatFrame adtdff = new Arg_DepthToDepthFloatFrame(pDepthImageData,
				countDepthImageDataBytes, pDepthFloatFrame, minDepthClip, maxDepthClip, mirrorDepth);

		int intRtn = JInvoker.callIntMethod(fusionColorReconst, IDX_DepthToDepthFloatFrame, adtdff);
		
		System.out.println("DepthToDepthFloatFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(adtdff.getLastError()));
		
		if (adtdff.getLastError() < 0) throw new Exception_KINECT("DepthToDepthFloatFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("DepthToDepthFloatFrame");

		return intRtn;
	}
	
	/*
	HRESULT SmoothDepthFloatFrame(
	         const NUI_FUSION_IMAGE_FRAME *pDepthFloatFrame,
	         const NUI_FUSION_IMAGE_FRAME *pSmoothDepthFloatFrame,
	         UINT kernelWidth,
	         FLOAT distanceThreshold
	)
	 */
	class Arg_SmoothDepthFloatFrame extends Arg_property {
		private long pDepthFloatFrame; // const NUI_FUSION_IMAGE_FRAME *
		private long pSmoothDepthFloatFrame; // const NUI_FUSION_IMAGE_FRAME *
		private int kernelWidth;
		private float distanceThreshold;

		Arg_SmoothDepthFloatFrame(long pDepthFloatFrame, long pSmoothDepthFloatFrame,
				int kernelWidth, float distanceThreshold) {
			this.pDepthFloatFrame = pDepthFloatFrame;
			this.pSmoothDepthFloatFrame = pSmoothDepthFloatFrame;
			this.kernelWidth = kernelWidth;
			this.distanceThreshold = distanceThreshold;
		}
	}
	
	int SmoothDepthFloatFrame(long pDepthFloatFrame, long pSmoothDepthFloatFrame,
			int kernelWidth, float distanceThreshold) throws Exception_KINECT {
		Arg_SmoothDepthFloatFrame asdff = new Arg_SmoothDepthFloatFrame(pDepthFloatFrame,
				pSmoothDepthFloatFrame, kernelWidth, distanceThreshold);

		int intRtn = JInvoker.callIntMethod(fusionColorReconst, IDX_SmoothDepthFloatFrame, asdff);
		
		System.out.println("SmoothDepthFloatFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(asdff.getLastError()));
		
		if (asdff.getLastError() < 0) throw new Exception_KINECT("SmoothDepthFloatFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("SmoothDepthFloatFrame");

		return intRtn;
	}

}
