package testkinect;

public class H_KinectInteraction {
	//#define NUI_USER_HANDPOINTER_COUNT 2
	static final int NUI_USER_HANDPOINTER_COUNT = 2;
	
	/*
	//Enumeration used to denominate a specific hand of a user.
	enum NUI_HAND_TYPE
	{
	    NUI_HAND_TYPE_NONE = 0,
	    NUI_HAND_TYPE_LEFT,
	    NUI_HAND_TYPE_RIGHT,
	};
	*/
	static final int
		NUI_HAND_TYPE_NONE  = 0,
		NUI_HAND_TYPE_LEFT  = 1,
		NUI_HAND_TYPE_RIGHT = 2;
	
	/*
	//Enumeration used to denominate an event triggered by some hand of some user.
	enum NUI_HAND_EVENT_TYPE
	{
	    NUI_HAND_EVENT_TYPE_NONE = 0,   // No change from last event, or an undefined change.
	    NUI_HAND_EVENT_TYPE_GRIP,       // Hand grip
	    NUI_HAND_EVENT_TYPE_GRIPRELEASE // Hand grip release
	};
	 */
	static final int
		NUI_HAND_EVENT_TYPE_NONE        = 0,
		NUI_HAND_EVENT_TYPE_GRIP        = 1,
		NUI_HAND_EVENT_TYPE_GRIPRELEASE = 2;
	
	/*
	//State flags that can be applied to a hand pointer.
	//Hand pointer could be tracked vs not tracked, pressed vs not pressed, etc.
	enum NUI_HANDPOINTER_STATE
	{
	    NUI_HANDPOINTER_STATE_NOT_TRACKED = 0x00,
	    NUI_HANDPOINTER_STATE_TRACKED = 0x01,           // Hand is tracked
	    NUI_HANDPOINTER_STATE_ACTIVE = 0x02,            // Hand is active within or near interaction region. In this state it is a candidate to become primary hand for user.
	    NUI_HANDPOINTER_STATE_INTERACTIVE = 0x04,       // Hand is in interaction region
	    NUI_HANDPOINTER_STATE_PRESSED = 0x08,           // Press happened in interaction region. Only possible in InteractionAdjuseHandPointers.
	    NUI_HANDPOINTER_STATE_PRIMARY_FOR_USER = 0x10   // This hand is the primary hand for user.
	};
	 */
	static final int
		NUI_HANDPOINTER_STATE_NOT_TRACKED      = 0x00,
		NUI_HANDPOINTER_STATE_TRACKED          = 0x01,
		NUI_HANDPOINTER_STATE_ACTIVE           = 0x02,
		NUI_HANDPOINTER_STATE_INTERACTIVE      = 0x04,
		NUI_HANDPOINTER_STATE_PRESSED          = 0x08,
		NUI_HANDPOINTER_STATE_PRIMARY_FOR_USER = 0x10;
	
}
