package testkinect;

class H_NuiImageCamera {
	/*
	typedef enum _NUI_IMAGE_TYPE
	{
	  NUI_IMAGE_TYPE_DEPTH_AND_PLAYER_INDEX = 0,            // USHORT
	  NUI_IMAGE_TYPE_COLOR,                                 // RGB32 data
	  NUI_IMAGE_TYPE_COLOR_YUV,                             // YUY2 stream from camera h/w, but converted to RGB32 before user getting it.
	  NUI_IMAGE_TYPE_COLOR_RAW_YUV,                         // YUY2 stream from camera h/w.
	  NUI_IMAGE_TYPE_DEPTH,                                 // USHORT
	  NUI_IMAGE_TYPE_COLOR_INFRARED,                        // USHORT
	  NUI_IMAGE_TYPE_COLOR_RAW_BAYER,                       // 8-bit Bayer
	} NUI_IMAGE_TYPE;
	 */
	static final int
		NUI_IMAGE_TYPE_DEPTH_AND_PLAYER_INDEX = 0,
		NUI_IMAGE_TYPE_COLOR                  = 1,
		NUI_IMAGE_TYPE_COLOR_YUV              = 2,
		NUI_IMAGE_TYPE_COLOR_RAW_YUV          = 3,
		NUI_IMAGE_TYPE_DEPTH                  = 4,
		NUI_IMAGE_TYPE_COLOR_INFRARED         = 5,
		NUI_IMAGE_TYPE_COLOR_RAW_BAYER        = 6;
	
	/*
	typedef enum _NUI_IMAGE_RESOLUTION
	{
	  NUI_IMAGE_RESOLUTION_INVALID = -1,
	  NUI_IMAGE_RESOLUTION_80x60 = 0,
	  NUI_IMAGE_RESOLUTION_320x240,
	  NUI_IMAGE_RESOLUTION_640x480,
	  NUI_IMAGE_RESOLUTION_1280x960                         // for hires color only
	} NUI_IMAGE_RESOLUTION;
	 */
	static final int
		NUI_IMAGE_RESOLUTION_INVALID  = -1,
		NUI_IMAGE_RESOLUTION_80x60    = 0,
		NUI_IMAGE_RESOLUTION_320x240  = 1,
		NUI_IMAGE_RESOLUTION_640x480  = 2,
		NUI_IMAGE_RESOLUTION_1280x960 = 3;
	
	/*
	typedef enum _NUI_IMAGE_DIGITALZOOM
	{
	    NUI_IMAGE_DIGITAL_ZOOM_1X = 0,
	} NUI_IMAGE_DIGITALZOOM;
	 */
	static final int
		NUI_IMAGE_DIGITAL_ZOOM_1X  = 0;
	
	/*
	#define NUI_IMAGE_PLAYER_INDEX_SHIFT          3
	#define NUI_IMAGE_PLAYER_INDEX_MASK           ((1 << NUI_IMAGE_PLAYER_INDEX_SHIFT)-1)
	 */
	static final int NUI_IMAGE_PLAYER_INDEX_SHIFT = 3;
	static final int NUI_IMAGE_PLAYER_INDEX_MASK = ((1 << NUI_IMAGE_PLAYER_INDEX_SHIFT)-1);
	
	/*
	// return S_FALSE instead of E_NUI_FRAME_NO_DATA if NuiImageStreamGetNextFrame( ) doesn't have a frame ready and a timeout != INFINITE is used
	#define NUI_IMAGE_STREAM_FLAG_SUPPRESS_NO_FRAME_DATA              0x00010000
	// Set the depth stream to near mode
	#define NUI_IMAGE_STREAM_FLAG_ENABLE_NEAR_MODE                    0x00020000
	// Use distinct values for depth values that are either too close, too far or unknown
	#define NUI_IMAGE_STREAM_FLAG_DISTINCT_OVERFLOW_DEPTH_VALUES      0x00040000
	 */
	static final int NUI_IMAGE_STREAM_FLAG_SUPPRESS_NO_FRAME_DATA         = 0x00010000;
	static final int NUI_IMAGE_STREAM_FLAG_ENABLE_NEAR_MODE               = 0x00020000;
	static final int NUI_IMAGE_STREAM_FLAG_DISTINCT_OVERFLOW_DEPTH_VALUES = 0x00040000;
	
	/*
	#define NUI_CAMERA_DEPTH_NOMINAL_FOCAL_LENGTH_IN_PIXELS         (285.63f)   // Based on 320x240 pixel size.
	 */
	static final float NUI_CAMERA_DEPTH_NOMINAL_FOCAL_LENGTH_IN_PIXELS         = 285.63f;

	/*
	#define NUI_CAMERA_COLOR_NOMINAL_FOCAL_LENGTH_IN_PIXELS         (531.15f)   // Based on 640x480 pixel size.
	 */
	static final float NUI_CAMERA_COLOR_NOMINAL_FOCAL_LENGTH_IN_PIXELS         = 531.15f;
	
	/*
	#define NUI_CAMERA_ELEVATION_MAXIMUM  27
	#define NUI_CAMERA_ELEVATION_MINIMUM (-27)
	 */
	static final int NUI_CAMERA_ELEVATION_MAXIMUM = 27;
	static final int NUI_CAMERA_ELEVATION_MINIMUM = -27;

}
