package testkinect;

import utildll.*;

/*
typedef struct _NUI_SKELETON_FRAME {
    LARGE_INTEGER liTimeStamp;
    DWORD dwFrameNumber;
    DWORD dwFlags;
    Vector4 vFloorClipPlane;
    Vector4 vNormalToGravity;
    NUI_SKELETON_DATA SkeletonData[NUI_SKELETON_COUNT];
} NUI_SKELETON_FRAME;
 */
class Struct_NUI_SKELETON_FRAME {
	long liTimeStamp;
	int dwFrameNumber;
	int dwFlags;
	@_Fixed Struct_Vector4 vFloorClipPlane = new Struct_Vector4();
	@_Fixed Struct_Vector4 vNormalToGravity = new Struct_Vector4();
	@_Fixed Struct_NUI_SKELETON_DATA[] SkeletonData = new Struct_NUI_SKELETON_DATA[H_NuiSkeleton.NUI_SKELETON_COUNT];
	
	Struct_NUI_SKELETON_FRAME() {
		for ( int i = 0; i < SkeletonData.length; i++) {
			SkeletonData[i] = new Struct_NUI_SKELETON_DATA();
		}
	}
}
