package testkinect;

import utildll.*;

/*
//Represents interaction information available about a specific user, including tracking ID
//and associated hand pointers.
struct NUI_USER_INFO
{
  DWORD SkeletonTrackingId;
  NUI_HANDPOINTER_INFO HandPointerInfos[NUI_USER_HANDPOINTER_COUNT];
};
*/
class Struct_NUI_USER_INFO {
	int SkeletonTrackingId;
	@_Fixed Struct_NUI_HANDPOINTER_INFO[] HandPointerInfos 
		= new Struct_NUI_HANDPOINTER_INFO[H_KinectInteraction.NUI_USER_HANDPOINTER_COUNT];
	
	Struct_NUI_USER_INFO() {
		for (int i = 0; i < HandPointerInfos.length; i++) {
			HandPointerInfos[i] = new Struct_NUI_HANDPOINTER_INFO();
		}
	}
}
