package testkinect;

import utildll.*;

public class Wrp_INuiCoordinateMapper {
	static final int CHARSET = Arg.UNICODE;
	long coordinateMapper = 0;
	static final int 
		IDX_Release = 2,
		IDX_MapDepthFrameToColorFrame = 7,
		IDX_MapSkeletonPointToColorPoint = 11;
	
	Wrp_INuiCoordinateMapper(long coordinateMapper) {
		this.coordinateMapper = coordinateMapper;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(coordinateMapper, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT MapDepthFrameToColorFrame(
	         NUI_IMAGE_RESOLUTION eDepthResolution,
	         DWORD cDepthPixels,
	         NUI_DEPTH_IMAGE_PIXEL *pDepthPixels,
	         NUI_IMAGE_TYPE eColorType,
	         NUI_IMAGE_RESOLUTION eColorResolution,
	         DWORD cColorPoints,
	         NUI_COLOR_IMAGE_POINT *pColorPoints
	)
	 */
	class Arg_MapDepthFrameToColorFrame extends Arg_property {
		private int eDepthResolution;
		private int cDepthPixels;
		private long pDepthPixels; // NUI_DEPTH_IMAGE_PIXEL *
		private int eColorType;
		private int eColorResolution;
		private int cColorPoints;
		private int[] pColorPoints; // NUI_COLOR_IMAGE_POINT *

		Arg_MapDepthFrameToColorFrame(int eDepthResolution, int cDepthPixels, long pDepthPixels,
				int eColorType, int eColorResolution, int cColorPoints, int[] pColorPoints) {
			this.eDepthResolution = eDepthResolution;
			this.cDepthPixels = cDepthPixels;
			this.pDepthPixels = pDepthPixels;
			this.eColorType = eColorType;
			this.eColorResolution = eColorResolution;
			this.cColorPoints = cColorPoints;
			this.pColorPoints = pColorPoints;
		}
	}

	int MapDepthFrameToColorFrame(int eDepthResolution, int cDepthPixels, long pDepthPixels,
			int eColorType, int eColorResolution, int cColorPoints, int[] pColorPoints)
			throws Exception_KINECT {
		Arg_MapDepthFrameToColorFrame amdftcf = new Arg_MapDepthFrameToColorFrame(eDepthResolution,
				cDepthPixels, pDepthPixels, eColorType, eColorResolution, cColorPoints, pColorPoints);

		int intRtn = JInvoker.callIntMethod(coordinateMapper, IDX_MapDepthFrameToColorFrame, amdftcf);
		
		System.out.println("MapDepthFrameToColorFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(amdftcf.getLastError()));
		
		if (amdftcf.getLastError() < 0) throw new Exception_KINECT("MapDepthFrameToColorFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("MapDepthFrameToColorFrame");

		return intRtn;
	}
	
	/*
	HRESULT MapSkeletonPointToColorPoint(
	         Vector4 *pSkeletonPoint,
	         NUI_IMAGE_TYPE eColorType,
	         NUI_IMAGE_RESOLUTION eColorResolution,
	         NUI_COLOR_IMAGE_POINT *pColorPoint
	)
	 */
	class Arg_MapSkeletonPointToColorPoint extends Arg_property {
		private Struct_Vector4 pSkeletonPoint;
		private int eColorType;
		private int eColorResolution;
		private int[] pColorPoint; // NUI_COLOR_IMAGE_POINT *

		Arg_MapSkeletonPointToColorPoint(Struct_Vector4 pSkeletonPoint, int eColorType,
				int eColorResolution, int[] pColorPoint) {
			this.pSkeletonPoint = pSkeletonPoint;
			this.eColorType = eColorType;
			this.eColorResolution = eColorResolution;
			this.pColorPoint = pColorPoint;
		}
	}
	
	int MapSkeletonPointToColorPoint(Struct_Vector4 pSkeletonPoint, int eColorType,
			int eColorResolution, int[] pColorPoint) throws Exception_KINECT {
		Arg_MapSkeletonPointToColorPoint amsptcp = new Arg_MapSkeletonPointToColorPoint(
				pSkeletonPoint,	eColorType, eColorResolution, pColorPoint);

		int intRtn = JInvoker.callIntMethod(coordinateMapper, IDX_MapSkeletonPointToColorPoint, amsptcp);
		
		System.out.println("MapSkeletonPointToColorPoint rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(amsptcp.getLastError()));
		
		if (amsptcp.getLastError() < 0) throw new Exception_KINECT("MapSkeletonPointToColorPoint");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("MapSkeletonPointToColorPoint");

		return intRtn;
	}
	
}
